/*main.m created by ahoesch on 25.11.2009 */

#import <Foundation/Foundation.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#define BUFLEN 512
#define NPACK 10
#define PORT 9930
//#define SRV_IP "127.0.0.1"

int main (int argc, const char *argv[])
  {
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   
   // insert your code here
     {
      struct sockaddr_in si_me, si_other;
      int s, i, slen=sizeof(si_other);
      char buf[BUFLEN];
      if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1) NSLog(@"socket failure");
      memset((char *) &si_me, 0, sizeof(si_me));
      si_me.sin_family = AF_INET;
      si_me.sin_port = htons(PORT);
      si_me.sin_addr.s_addr = htonl(INADDR_ANY);
      if (bind(s, &si_me, sizeof(si_me))==-1) NSLog(@"bind failed");
      for (i=0; i<NPACK; i++)
        {
         if (recvfrom(s, buf, BUFLEN, 0, &si_other, &slen)==-1)NSLog(@"recvfrom()");
         printf("Received packet from %s:%d\nData: %s\n\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port), buf);     
        }
     }
   
   [pool release];
   exit(0);       // insure the process exit status is 0
   return 0;      // ...and make main fit the ANSI spec.
  }
